/*
 * linux/include/asm-arm/arch-vnc/time.h
 *
 * Copyright (c) 1997 Corel Computer Corp
 *
 */

#define MCLK_47_8

#define TIMER_CLEAR (timer_base + 3)
#define TIMER_CONTROL (timer_base + 2)
#define TIMER_VALUE (timer_base + 1)
#define TIMER_LOAD (timer_base)

volatile unsigned int * timer_base = IO_BASE_ARM_CSR + TIMER_1_LOAD;

extern __inline__ unsigned long gettimeoffset (void)
{
	return 0;
}

extern __inline__ int reset_timer (void)
{  
        *TIMER_CLEAR = 0;
	return 1;
}

extern __inline__ unsigned long setup_timer (void)
{
        unsigned int mode ; 
        /* rev 5 boards use the other clock */
	if ((board_id & 0xF000) == 0x5000) {
		timer_base = 
			(volatile unsigned int *) (IO_BASE_ARM_CSR + TIMER_3_LOAD);
		*TIMER_LOAD = mSEC_10_from_14;
		mode = *TIMER_CONTROL ;
		/* set for external pin counter */
		mode |= TIMER_CONTROL_ENABLE | TIMER_AUTO_RELOAD | 0x0C;
		*TIMER_CONTROL = mode ;
	}
	else 
	{
		*TIMER_LOAD = mSEC_10;
		mode = *TIMER_CONTROL ;
		mode |= TIMER_CONTROL_ENABLE | TIMER_AUTO_RELOAD;
		*TIMER_CONTROL = mode ;
	}
       	*TIMER_CLEAR = 1 ;
	
	/*
	 * Default the date to 1 Jan 1970 0:0:0
	 * You will have to run a time daemon to set the
	 * clock correctly at bootup
	 */
	return mktime(1970, 1, 1, 0, 0, 0);
}
